SystemOrganization addCategory: #PullUpToSuperclass!
SystemOrganization addCategory: #'PullUpToSuperclass-subject'!

Object subclass: #PullUpToSuperclass
	instanceVariableNames: 'classes commonSuperclass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PullUpToSuperclass'!

!PullUpToSuperclass commentStamp: 'HwaJong 5/3/2013 21:44' prior: 0!
m := PullUpToSuperclass new.
m commonSuperclass: Wooluspos.
m run.!

!PullUpToSuperclass methodsFor: 'accessing' stamp: 'HwaJong 5/3/2013 21:43'!
commonSuperclass: aClass
	commonSuperclass := aClass! !

!PullUpToSuperclass methodsFor: 'operations' stamp: 'HwaJong 5/3/2013 20:25'!
moveInstanceVariables

	|commonInstanceVariables|
	commonInstanceVariables := classes inject: classes anyOne instVarNames into: [:ivs :clss| ivs intersection: clss instVarNames].
	
	commonInstanceVariables do: [:iVarName| 
		(RBPullUpInstanceVariableRefactoring
			model: (RBNamespace onEnvironment: RBBrowserEnvironment new) variable: iVarName class: commonSuperclass) execute].

! !

!PullUpToSuperclass methodsFor: 'operations' stamp: 'HwaJong 5/3/2013 21:14'!
moveMethods

	|classToMethods commonSelectors|
	classToMethods := classes collect: [:each|  each -> ((each methods reject: [:m| m sendsToSuper]) reject: [:m| m sendsToSuper and: [commonSuperclass selectors include: m selector]]) ].
	
	commonSelectors := classToMethods inject: (classToMethods anyOne value collect: #selector) into: [:ivs :assoc| ivs intersection: (assoc value collect: #selector)].
	classToMethods do: [:assoc| assoc value: (assoc value select: [:me| commonSelectors includes: me selector]) ].
	
	commonSelectors := commonSelectors select: [:sel| (classToMethods collect: [:ass| ass key sourceCodeAt: sel]) asSet size = 1 ].
	
	commonSelectors do: [:yesSel| 
		|code cats cat|
		cats := (classes collect: [:cls| (cls compiledMethodAt: yesSel) category ]) copyWithoutAll: { #'as yet unclassified'}.
		cat := cats isEmpty ifTrue: [ #'as yet unclassified'] ifFalse: [cats asBag sortedCounts first value].
		code := classes anyOne sourceCodeAt: yesSel.
		commonSuperclass compile: code classified: cat.
		classes do: [:cls| cls removeSelector: yesSel]].! !

!PullUpToSuperclass methodsFor: 'operations' stamp: 'HwaJong 5/3/2013 21:42'!
run
	classes := commonSuperclass subclasses.
	self moveInstanceVariables.
	self moveMethods.! !

Object subclass: #Wooluspos
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PullUpToSuperclass-subject'!

Wooluspos subclass: #WoolClass1
	instanceVariableNames: 'a b c'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PullUpToSuperclass-subject'!

!WoolClass1 methodsFor: 'accessing' stamp: 'HwaJong 5/3/2013 20:21'!
a
	^ a! !

!WoolClass1 methodsFor: 'accessing' stamp: 'HwaJong 5/3/2013 20:21'!
a: anObject
	a := anObject! !

!WoolClass1 methodsFor: 'accessing' stamp: 'HwaJong 5/3/2013 20:21'!
b
	^ b! !

!WoolClass1 methodsFor: 'accessing' stamp: 'HwaJong 5/3/2013 20:21'!
b: anObject
	b := anObject! !

!WoolClass1 methodsFor: 'accessing' stamp: 'HwaJong 5/3/2013 22:22'!
c
	^ c! !

!WoolClass1 methodsFor: 'accessing' stamp: 'HwaJong 5/3/2013 22:22'!
c: anObject
	c := anObject! !

!WoolClass1 methodsFor: 'category1' stamp: 'HwaJong 5/3/2013 23:04'!
iShouldBeCategorizedTo1
	^self! !

!WoolClass1 methodsFor: 'category1' stamp: 'HwaJong 5/3/2013 23:03'!
iShouldBeCategorizedTo2
	^self! !

!WoolClass1 methodsFor: 'as yet unclassified' stamp: 'HwaJong 5/3/2013 22:24'!
sourceCodeIsNotExactlySame
	^'hello'! !

!WoolClass1 methodsFor: 'as yet unclassified' stamp: 'HwaJong 5/3/2013 22:37'!
superSendsAndSuperclassHaveMe
	^super yourself! !

!WoolClass1 methodsFor: 'as yet unclassified' stamp: 'HwaJong 5/3/2013 22:38'!
superSendsAndSuperclassHaveMeButCodeIsSame
	^super yourself! !

!WoolClass1 methodsFor: 'as yet unclassified' stamp: 'HwaJong 5/3/2013 22:25'!
superSendsButSuperclassDoesNotHaveMe
	^super yourself! !

Wooluspos subclass: #WoolClass2
	instanceVariableNames: 'b d c'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PullUpToSuperclass-subject'!

!WoolClass2 methodsFor: 'accessing' stamp: 'HwaJong 5/3/2013 20:22'!
b
	^ b! !

!WoolClass2 methodsFor: 'accessing' stamp: 'HwaJong 5/3/2013 20:22'!
b: anObject
	b := anObject! !

!WoolClass2 methodsFor: 'accessing' stamp: 'HwaJong 5/3/2013 22:22'!
c
	^ c! !

!WoolClass2 methodsFor: 'accessing' stamp: 'HwaJong 5/3/2013 22:22'!
c: anObject
	c := anObject! !

!WoolClass2 methodsFor: 'accessing' stamp: 'HwaJong 5/3/2013 20:22'!
d
	^ d! !

!WoolClass2 methodsFor: 'accessing' stamp: 'HwaJong 5/3/2013 20:22'!
d: anObject
	d := anObject! !

!WoolClass2 methodsFor: 'as yet unclassified' stamp: 'HwaJong 5/3/2013 23:04'!
iShouldBeCategorizedTo1
	^self! !

!WoolClass2 methodsFor: 'category2' stamp: 'HwaJong 5/3/2013 23:03'!
iShouldBeCategorizedTo2
	^self! !

!WoolClass2 methodsFor: 'as yet unclassified' stamp: 'HwaJong 5/3/2013 22:24'!
sourceCodeIsNotExactlySame
	^'bye'! !

!WoolClass2 methodsFor: 'as yet unclassified' stamp: 'HwaJong 5/3/2013 22:37'!
superSendsAndSuperclassHaveMe
	^super yourself! !

!WoolClass2 methodsFor: 'as yet unclassified' stamp: 'HwaJong 5/3/2013 22:38'!
superSendsAndSuperclassHaveMeButCodeIsSame
	^super yourself! !

!WoolClass2 methodsFor: 'as yet unclassified' stamp: 'HwaJong 5/3/2013 22:25'!
superSendsButSuperclassDoesNotHaveMe
	^super yourself! !

Wooluspos subclass: #WoolClass3
	instanceVariableNames: 'a d c'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PullUpToSuperclass-subject'!

!WoolClass3 methodsFor: 'accessing' stamp: 'HwaJong 5/3/2013 20:22'!
a
	^ a! !

!WoolClass3 methodsFor: 'accessing' stamp: 'HwaJong 5/3/2013 20:22'!
a: anObject
	a := anObject! !

!WoolClass3 methodsFor: 'accessing' stamp: 'HwaJong 5/3/2013 22:22'!
c
	^ c! !

!WoolClass3 methodsFor: 'accessing' stamp: 'HwaJong 5/3/2013 22:22'!
c: anObject
	c := anObject! !

!WoolClass3 methodsFor: 'accessing' stamp: 'HwaJong 5/3/2013 20:22'!
d
	^ d! !

!WoolClass3 methodsFor: 'accessing' stamp: 'HwaJong 5/3/2013 20:22'!
d: anObject
	d := anObject! !

!WoolClass3 methodsFor: 'as yet unclassified' stamp: 'HwaJong 5/3/2013 23:04'!
iShouldBeCategorizedTo1
	^self! !

!WoolClass3 methodsFor: 'category2' stamp: 'HwaJong 5/3/2013 23:03'!
iShouldBeCategorizedTo2
	^self! !

!WoolClass3 methodsFor: 'as yet unclassified' stamp: 'HwaJong 5/3/2013 22:24'!
sourceCodeIsNotExactlySame
	^'hello'! !

!WoolClass3 methodsFor: 'as yet unclassified' stamp: 'HwaJong 5/3/2013 22:37'!
superSendsAndSuperclassHaveMe
	^super yourself! !

!WoolClass3 methodsFor: 'as yet unclassified' stamp: 'HwaJong 5/3/2013 22:38'!
superSendsAndSuperclassHaveMeButCodeIsSame
	^super yourself! !

!WoolClass3 methodsFor: 'as yet unclassified' stamp: 'HwaJong 5/3/2013 22:25'!
superSendsButSuperclassDoesNotHaveMe
	^super yourself! !

!Wooluspos methodsFor: 'as yet unclassified' stamp: 'HwaJong 5/3/2013 22:37'!
superSendsAndSuperclassHaveMe
	^super yourself yourself! !

!Wooluspos methodsFor: 'as yet unclassified' stamp: 'HwaJong 5/3/2013 22:38'!
superSendsAndSuperclassHaveMeButCodeIsSame
	^super yourself! !
